
// FirstAppDlg.h : wb_[ t@C
//

#pragma once

#include "OPN2002iBluetoothService.h"
#include "afxwin.h"


// CFirstAppDlg _CAO
class CFirstAppDlg 
  : public CDialogEx
  , public IOPN2002iBluetoothServiceDelegate
{
public:
	CFirstAppDlg(CWnd* pParent = NULL);	// WRXgN^[
	~CFirstAppDlg();

	// _CAO f[^
	enum { IDD = IDD_FIRSTAPP_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	HICON m_hIcon;
	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

private:
	CEdit m_eTerminal;
	CListBox m_lSearchedDevices;

  OPN2002iBluetoothService &m_service;
	CArray<OPNBluetoothDevice> m_arrDevices; //!< foCXꗗ

  void ShowData(BYTE *data);
	void AddTerminalStr(CString str);

  // IOPN2002iBluetoothServiceDelegate
  void OnDidGetFirmware( 
    OPNBluetoothService *pService,
    BYTE* pData 
    );
	void OnReceiveBarcode( 
    OPNBluetoothService *pService, 
    BYTE* pData );
	void OnDidConnectDevice( 
    OPNBluetoothService *pService, 
    OPNBluetoothDevice* pDevice 
    );
	void OnDidDisconnectDevice( 
    OPNBluetoothService *pService, 
    OPNBluetoothDevice* pDevice 
    );
	void OnDidDiscoveredDevice( 
    OPNBluetoothService *pService, 
    OPNBluetoothDevice pDevice 
    );
	void OnCompleteDiscovery( 
    OPNBluetoothService *pService, 
    INT nDeviceCount 
    );
  BOOL OnRequestPinCode(
    OPNBluetoothService *pService,
    LPSTR lpszPinCode
    );
	
	afx_msg void OnBnClickedSlaveButton();
	afx_msg void OnBnClickedSearchButton();
	afx_msg void OnBnClickedDesconnectButton();
	afx_msg void OnBnClickedStartServerButton();
	afx_msg void OnBnClickedGetFirmwareVersionButton();
	afx_msg void OnBnClickedBuzzerOnButton();

};
