//
// Copyright (c) 2013 OPTOELECTRONICS CO., LTD. All rights reserved
//

#ifndef OPNTERMLIB__OPNBLUETOOTHDEVICE_H_
#define OPNTERMLIB__OPNBLUETOOTHDEVICE_H_

#include "stdafx.h"

#pragma warning(disable:4068)
#include <BluetoothAPIs.h>
#pragma warning(default:4068)

#include "OPNErrors.h"

/**
* @class OPNBluetoothDevice
* @brief BluetoothfoCXNX
*
* foCX̏ێ܂B
*/
class OPNBluetoothDevice
{
public:
  /**
  * @brief RXgN^
  */
  OPNBluetoothDevice();

  /**
  * @brief RXgN^iAPÎݎgpj
  * @param[in] bthDevice BLUETOOTH_DEVICE_INFO̎
  */
  OPNBluetoothDevice( BLUETOOTH_DEVICE_INFO bthDevice );

  /**
  * @brief fXgN^
  */
  ~OPNBluetoothDevice();

  /**
  * @brief Rs[RXgN^
  */
  OPNBluetoothDevice( const OPNBluetoothDevice &instance );

  /**
  * @brief ZqɂRs[
  */
  OPNBluetoothDevice& operator= ( const OPNBluetoothDevice &instance );

  /**
  * @brief o[R[hRN^̃foCX擾܂B
  * @param[out] lpszName foCX
  * @param[in] nLen lpszNamẽoCg
  * @return TRUEF擾/FALSEF擾s
  */
  OPNResult GetName( LPSTR lpszName, INT nLen );

  /**
  * @brief o[R[hRN^̃AhX擾܂B
  * @param[out] lpszBthAddr AhX
  * @param[in] nLen lpszBthAddr̃oCg
  * @return TRUEF擾/FALSEF擾s
  */
  OPNResult GetAddress( LPSTR lpszBthAddr, INT nLen );

  /**
  * @brief o[R[hRN^̃AhX擾܂B 
  * @return o[R[hRN^̃AhX
  */
  ULONGLONG GetUAddress();

private:
  class Impl;
  Impl *m_impl;
};
#endif // OPNTERMLIB__OPNBLUETOOTHDEVICE_H_