//
// Copyright (c) 2013 OPTOELECTRONICS CO., LTD. All rights reserved
//

#ifndef OPNTERMDESKTOP__OPNSETTINGCHARS_H_
#define OPNTERMDESKTOP__OPNSETTINGCHARS_H_

#include "stdafx.h"

/// OPNSettingCharš
#define OPN_SETTING_CHAR_NUM 142


/** 
* @struct SettingChar
* @brief ݒR}h̍\
*/
typedef struct SettingChar {
	/*! vtBbNXETtBbNX̕\e  */
	const char *name;
	/*! R}h */
	const char *command;
	/*! vtBbNXETtBbNX */
	UINT16 pfsf;
} SettingChar;

/** 
* @class OPNSettingChars
* @brief SettingChar\̂₷wp[NX
* ꗗ̎擾AvtBbNXETtBbNXR}h邱Ƃł܂B
* ̃NX̓AvɂP̂ݑ݂[GoF]SingletonNXłB
* 
*/
class OPNSettingChars {
protected:
	/// @brief RXgN^
	OPNSettingChars();
	/// @brief fXgN^
	~OPNSettingChars();
public:
	/**
	* @brief OPNSettingChars̃CX^X擾܂B
	* @return CX^X
	*/
	static OPNSettingChars &GetInstance();

	/**
	* @brief ݒR}hꗗzƂĎ擾܂B
	* 
	* @return SettingChar̔ziTCYOPN_SETTING_CHAR_NUMj
	*/
	const SettingChar *GetSettingChars();

	/**
	* @brief vtBbNXETtBbNX̃rbgz񂩂R}h̍\̂擾܂B
	* ΉR}hȂꍇ́ÃR}h\̂Ԃ܂B
	* @param[in] pfsf vtBbNXETtBbNX̃rbg
	* @return R}h̍\́@ΉR}hȂꍇ́ÃR}h\̂Ԃ܂B
	*/
	static const SettingChar GetSettingChar(UINT16 pfsf);

	/**
	 * @brief pfsfoCgz񂩂R}h\̂擾܂B
	 * @param[in] pfsf pfsf̃oCgz
	 * @return R}h̍\
	 */
	const SettingChar GetSettingChar(const unsigned char *pfsf);

	/**
	* @brief \R}h擾܂B
	* ΉR}hȂꍇ͂當Ԃ܂B
	* @param[in] str \
	* @return R}h ΉR}hȂꍇ͋󕶎Ԃ܂B
	*/
	const char *GetCommandString(const char * str);

private:
	/** 
	* @brief [JCYꂽ擾܂B
	* @param[in] uStringID ID
	* @param[out] out [JCYꂽ
	*/
	void GetLocalizedString(UINT uStringID , char *out);

	///
	char *m_empty;
	///
	char *m_year;         
	///
	char *m_month;         
	///
	char *m_day;           
	///
	char *m_hour;          
	///
	char *m_minute;        
	///
	char *m_second;        
	///
	char *m_scanCount;     
	///
	char *m_barcodeType;   
	///
	char *m_barcodeLength; 
	///
	char *m_batteryVoltage;
	///
	char *m_bdAdress;      
	///
	char *m_terminalID;    
	///
	char *m_terminalName; 
	///
	SettingChar *m_settingChars;

};

#endif