//
//  AppDelegate.m
//  FirstApp
//
//  Copyright (c) 2012年  OPTO ELECTRONICS Co.,LTD. All rights reserved.
//

#import "AppDelegate.h"

#import <OPNBluetoothKit/OPN2002iBluetoothService.h>

@implementation AppDelegate

@synthesize window = _window;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    return YES;
}
							
- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    OPN2002iBluetoothService *sessionController = [OPN2002iBluetoothService sharedController];
    [sessionController openSession];
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    OPN2002iBluetoothService *sessionController = [OPN2002iBluetoothService sharedController];
    [sessionController closeSession];
}

@end
