
// FirstAppDlg.cpp : t@C
//

#include "stdafx.h"
#include "FirstApp.h"
#include "FirstAppDlg.h"
#include "afxdialogex.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

	// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CFirstAppDlg _CAO


CFirstAppDlg::CFirstAppDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CFirstAppDlg::IDD, pParent)
  , m_service( OPN2002iBluetoothService::GetInstance() )
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CFirstAppDlg::~CFirstAppDlg()
{
	m_arrDevices.RemoveAll();
}

void CFirstAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT, m_eTerminal);
	DDX_Control(pDX, IDC_LIST1, m_lSearchedDevices);
}

BEGIN_MESSAGE_MAP(CFirstAppDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START_SERVER_BUTTON, &CFirstAppDlg::OnBnClickedStartServerButton)
	ON_BN_CLICKED(IDC_GET_FIRMWARE_VERSION_BUTTON, &CFirstAppDlg::OnBnClickedGetFirmwareVersionButton)
	ON_BN_CLICKED(IDC_SLAVE_BUTTON, &CFirstAppDlg::OnBnClickedSlaveButton)
	ON_BN_CLICKED(IDC_SEARCH_BUTTON, &CFirstAppDlg::OnBnClickedSearchButton)
	ON_BN_CLICKED(IDC_DESCONNECT_BUTTON, &CFirstAppDlg::OnBnClickedDesconnectButton)
	ON_BN_CLICKED(IDC_BUZZER_ON_BUTTON, &CFirstAppDlg::OnBnClickedBuzzerOnButton)
END_MESSAGE_MAP()


// CFirstAppDlg bZ[W nh[

BOOL CFirstAppDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
  m_service.SetDelegate( this );

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CFirstAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CFirstAppDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CFirstAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CFirstAppDlg::OnBnClickedStartServerButton()
{
	m_service.StartServer();
}

void CFirstAppDlg::OnBnClickedGetFirmwareVersionButton()
{
	m_service.GetFirmwareVersion();
}

void CFirstAppDlg::OnBnClickedSearchButton()
{
	m_lSearchedDevices.ResetContent();

	m_arrDevices.RemoveAll();

  // foCXJn
	m_service.DoDiscoveryAsync();
}

void CFirstAppDlg::OnDidDiscoveredDevice( 
  OPNBluetoothService *pService, 
  OPNBluetoothDevice pDevice )
{
	m_arrDevices.Add( pDevice );

	CHAR szName[BLUETOOTH_MAX_NAME_SIZE] = { 0 };
	CHAR szAddr[32] = { 0 };

	pDevice.GetName( szName, BLUETOOTH_MAX_NAME_SIZE );
	pDevice.GetAddress( szAddr, 32 );

	CString strRowText;
	strRowText.Format( _T("%s  %s"), szName, szAddr );
	m_lSearchedDevices.AddString( strRowText );
}

void CFirstAppDlg::OnCompleteDiscovery( 
  OPNBluetoothService *pService, 
  INT nDeviceCount )
{
	OutputDebugString( "foCX܂" );
}

void CFirstAppDlg::OnBnClickedSlaveButton()
{
	//  ʃXgIԂ̎擾
	const int indexs = m_lSearchedDevices.GetCurSel();
	if ( indexs > -1 ) {
		OPNBluetoothDevice device = m_arrDevices[indexs];
		m_service.Connect( device, FALSE );
	}
}

void CFirstAppDlg::OnBnClickedDesconnectButton()
{
	m_service.Disconnect();
}

void CFirstAppDlg::OnBnClickedBuzzerOnButton()
{
	m_service.PushCommand( "P3" );
	m_service.PushCommand( "B");
	m_service.StartSendCommands();
}

void CFirstAppDlg::ShowData( BYTE *data ) 
{
	CString nextStr(data);
	// sR[hi\rjWindows̉sR[hɒu
	nextStr.Replace("\r", "\r\n");
	nextStr.Replace("\x6", "");
	AddTerminalStr(nextStr);
}

void CFirstAppDlg::AddTerminalStr(CString str) 
{
	const int nLen = m_eTerminal.GetWindowTextLength();
	m_eTerminal.SetFocus();
	m_eTerminal.SetSel(nLen, nLen);
	m_eTerminal.ReplaceSel(str);
}

void CFirstAppDlg::OnDidGetFirmware( 
  OPNBluetoothService *pService, 
  BYTE* pData )
{
	ShowData(pData);
}

void CFirstAppDlg::OnReceiveBarcode( 
  OPNBluetoothService *pService, 
  BYTE* pData ) 
{
	ShowData(pData);
}

void CFirstAppDlg::OnDidConnectDevice( 
  OPNBluetoothService *pService, 
  OPNBluetoothDevice* pDevice ) 
{
	MessageBox("foCXƐڑ܂B", MB_OK );
}

void CFirstAppDlg::OnDidDisconnectDevice( 
  OPNBluetoothService *pService, 
  OPNBluetoothDevice* pDevice ) 
{
	MessageBox("foCXƐؒf܂B", MB_OK );
}

BOOL CFirstAppDlg::OnRequestPinCode( 
  OPNBluetoothService *pService, 
  LPSTR lpszPinCode ) 
{
  // PINR[hݒ
  CopyMemory( lpszPinCode, "1234", 4 );
  return TRUE;  
}