VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "FirstApp"
   ClientHeight    =   7230
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8565
   LinkTopic       =   "Form1"
   ScaleHeight     =   7230
   ScaleWidth      =   8565
   StartUpPosition =   3  'Windows ̊l
   Begin VB.CommandButton BuzzerOnBtn 
      Caption         =   "Buzzer ON"
      Height          =   735
      Left            =   4560
      TabIndex        =   10
      Top             =   6000
      Width           =   3855
   End
   Begin VB.CommandButton GetFirmwareVersionBtn 
      Caption         =   "GetFirmwareVersion"
      Height          =   735
      Left            =   4560
      TabIndex        =   9
      Top             =   5160
      Width           =   3855
   End
   Begin VB.TextBox Text1 
      Height          =   4455
      Left            =   4560
      MultiLine       =   -1  'True
      ScrollBars      =   2  '
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   240
      Width           =   3855
   End
   Begin VB.CommandButton ConnectServerBtn 
      Caption         =   "Connect(Server)"
      Height          =   705
      Left            =   240
      TabIndex        =   4
      Top             =   5160
      Width           =   3855
   End
   Begin VB.Frame Frame2 
      Caption         =   "Connect(Server)"
      Height          =   1935
      Left            =   120
      TabIndex        =   6
      Top             =   4920
      Width           =   4095
      Begin VB.CommandButton DisConnectBtn 
         Caption         =   "Disconnect"
         Height          =   735
         Left            =   120
         TabIndex        =   5
         Top             =   1080
         Width           =   3855
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Connect(Slave)"
      Height          =   4575
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4095
      Begin VB.CommandButton ConnectSlaveBtn 
         Caption         =   "Connect(Slave)"
         Height          =   735
         Left            =   120
         TabIndex        =   3
         Top             =   3720
         Width           =   3855
      End
      Begin VB.CommandButton DeviceSearchBtn 
         Caption         =   "Search Devices"
         Height          =   735
         Left            =   120
         TabIndex        =   2
         Top             =   2880
         Width           =   3855
      End
      Begin VB.ListBox SearchList 
         Height          =   1860
         Left            =   120
         TabIndex        =   1
         Top             =   600
         Width           =   3855
      End
      Begin VB.Label Label1 
         Caption         =   "Search device result"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   360
         Width           =   3615
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Base 0
Option Explicit

' WOPN2002iBluetoothService Cxg`
Public WithEvents opnService As OPNTermComDllLib.WOPN2002iBluetoothService
Attribute opnService.VB_VarHelpID = -1

' foCX
Public nDeviceCount As Long

' Form֐
Private Sub Form_Initialize()

    Dim nDeviceCount As Long
    nDeviceCount = 0
    
    ' WOPN2002iBluetoothService ̃CX^X쐬܂B
    Set opnService = New OPNTermComDllLib.WOPN2002iBluetoothService
    
    ' ܂B
    Call opnService.Initialize

End Sub

' Search Devices {^֐
Private Sub DeviceSearchBtn_Click()

    Dim opnResult As WOPNResult

    ' ʃXg{bNXNA܂B
    SearchList.Clear
    
    ' foCXʔzNA܂
    Erase opnDevices
    nDeviceCount = 0

    ' foCX܂B
    opnResult = opnService.DoDiscoveryAsync()

End Sub

' Connect(Slave){^֐
' foCXڑ܂B
Private Sub ConnectSlaveBtn_Click()

    Dim opnResult As WOPNResult
    Dim iSelectedIndex As Integer
    
    ' I𒆂̌ʃXg̃CfbNX擾܂B
    iSelectedIndex = SearchList.ListIndex()
    
    ' I𒆂̏ꍇAڑ܂B
    If iSelectedIndex > -1 Then
        ' CZLAŐڑ܂B
        opnResult = opnService.Connect(opnDevices(iSelectedIndex), True)
        Debug.Print opnResult
    End If

End Sub

' Connect(Server){^֐
Private Sub ConnectServerBtn_Click()

    Dim opnResult As WOPNResult

    ' T[o[Jn܂B
    opnResult = opnService.StartServer()
    
End Sub

' Diconnect{^֐
' foCXؒf܂B
Private Sub DisConnectBtn_Click()

    Dim bSuccess As Boolean
    
    ' T[o[~܂B
    bSuccess = opnService.Disconnect()

End Sub

' GetFirmwareVersion{^֐
Private Sub GetFirmwareVersionBtn_Click()

    Dim opnResult As WOPNResult

    ' API GetFirmwareVersion s܂B
    opnResult = opnService.GetFirmwareVersion()

End Sub

' BuzzerOn{^֐
Private Sub BuzzerOnBtn_Click()
    
    Dim opnResult As WOPNResult

    ' uU[OÑR}hݒ肵܂B
    opnService.PushCommand ("P3")
    opnService.PushCommand ("B")
    
    ' R}h𑗐M܂B
    opnResult = opnService.StartSendCommands()

End Sub

' ؒfCxg
Private Sub opnService_OnDidDisconnectDeviceEvent(ByVal pDevice As IWOPNBluetoothDevice)
    
    Call MsgBox("ؒf܂")
    
    Dim opnResult As WOPNResult
    opnResult = opnService.StartAutoConnect()
    
End Sub

' ڑCxg
Private Sub opnService_OnDidConnectDeviceEvent(ByVal pDevice As IWOPNBluetoothDevice)
    
    Dim opnResult As WOPNResult
    opnResult = opnService.StopAutoConnect()
    
    Call MsgBox("ڑ܂")

End Sub

' PINR[h͗vCxg
Public Function opnService_OnRequestPinCodeEvent(pinCode As String) As Boolean
    pinCode = "1234"
    opnService_OnRequestPinCodeEvent = True
End Function

' foCXmCxg
Private Sub opnService_OnDidDiscoveredDeviceEvent(ByVal pDevice As IWOPNBluetoothDevice)
    
    Dim strRowText As String
    Dim lInsertIndex As Long
    
    ' foCXʃXg{bNXɍsǉ܂B
    strRowText = pDevice.Name + "   " + pDevice.Address
    SearchList.AddItem (strRowText)
    
    nDeviceCount = nDeviceCount + 1
    
    ReDim Preserve opnDevices(0 To nDeviceCount)
    
    Set opnDevices(nDeviceCount - 1) = pDevice
    
End Sub

' GetFirmwareICxg
Private Sub opnService_OnDidGetFirmwareEvent(ByVal pData As Variant)

    Dim strVersion As String
    Dim i As Integer
    
    ' pDatãoCgAeLXg{bNXɕҏW
    '   sAck𖳎
    For i = LBound(pData, 1) To UBound(pData, 1) - 1
        If -1 < pData(0) Then
            strVersion = strVersion + Chr(pData(i))
        End If
    Next i
    Text1.Text = Text1.Text + strVersion
    
    ' AR[hΕAsR[ht܂B
    If -1 < InStr(strVersion, vbCr) Then
        Text1.Text = Text1.Text + vbCrLf
    End If

End Sub

' o[R[hMCxg
Private Sub opnService_OnReceiveBarcodeEvent(ByVal pData As Variant)

    Dim strData As String
    Dim i As Integer
    
    ' pDatãoCgAeLXg{bNXɕҏW
    For i = LBound(pData, 1) To UBound(pData, 1)
        If -1 < pData(0) Then
            strData = strData + Chr(pData(i))
        End If
    Next i
    Text1.Text = Text1.Text + strData
    
    ' AR[hΕAsR[ht܂B
    If -1 < InStr(strData, vbCr) Then
        Text1.Text = Text1.Text + vbCrLf
    End If

End Sub

' Form UnloadCxg
Private Sub Form_Unload(Cancel As Integer)

    ' OPN2002iBluetoothService CxgJ܂B
    Set opnService = Nothing

End Sub

