#ifndef BTHSCANNER_H_
#define BTHSCANNER_H_

#include <vector>
#include "BTHCore.h"

class BTHScanner;

/**
* @class IBTHScannerDelegate
* @brief BTHScannerNẌϏNX
*/
class IBTHScannerDelegate {
public:
	/**
	* @brief OnDiscoveryAsync \bhŃfoCX1䔭ƌĂяo܂
	* @param[in] pScanner ڑBTHScannerNX̃CX^X
	* @param[in] btdi foCX̃CX^X
	*/
	virtual VOID OnDidDiscoveredDevice( BTHScanner *pScanner, BLUETOOTH_DEVICE_INFO btdi ) = 0;

	/**
	* @brief OnDiscoveryAsync \bhŃfoCXTƌĂяo܂
	* @param[in] pScanner ڑBTHScannerNX̃CX^X
	* @param[in] iDeviceCount [̑䐔
	*/
	virtual VOID OnCompleteDiscovery( BTHScanner *pScanner, INT iDeviceCount ) = 0;
};

/**
* @class BTHScanner
* @brief foCXTNX
*/
class BTHScanner
{
public:
	/// RXgN^
	BTHScanner(void);
	/// fXgN^
	~BTHScanner(void);

	/**
	* @brief foCX𓯊IɒT܂B
	* @param[out] Tʂ̃Xgi[܂B
	* @param[in] Tԁibj
	* @return  BTHCORE_SUCCESS Ԃ܂B
	*/
	LONG DoDiscovery( std::vector<BLUETOOTH_DEVICE_INFO> *pBthDevices, INT nTimeout );

	/**
	* @brief yAOς݂̃foCX𓯊IɒT܂B
	* @param[out] Tʂ̃Xgi[܂B
	* @return  BTHCORE_SUCCESS Ԃ܂B
	*/
	LONG GetPairedDevices( std::vector<BLUETOOTH_DEVICE_INFO> *pBthDevices );

	/**
	* @brief foCX񓯊ŒT܂B
	* @param[in] fQ[^
	* @return  BTHCORE_SUCCESS Ԃ܂B
	*/
	LONG DoDiscoveryAsync( IBTHScannerDelegate *pDelegate );

	/**
	* @brief DoDiscoveryAsync ̎sLZ܂B
	* @return  BTHCORE_SUCCESS Ԃ܂B
	*/
	LONG CancelDiscovery();

  /**
  * @brief ׂẴfoCX폜܂B
  * @return  BTHCORE_SUCCESS Ԃ܂B
  */
  LONG RemoveAllDevices();

private:
	// PimplCfBIiRs[֎~j
	class Impl;
	Impl *m_impl;
	// Rs[RXgN^
	BTHScanner( const BTHScanner& instance );
	// ZqɂRs[
	BTHScanner& operator= ( const BTHScanner& instance );
};
#endif //BTHSCANNER_H_
