//
// Copyright (c) 2013 OPTOELECTRONICS CO., LTD. All rights reserved
//

#ifndef OPNTERMDESKTOP__OPN2002iBluetoothService_H_
#define OPNTERMDESKTOP__OPN2002iBluetoothService_H_
#pragma warning(disable:4068)

#include "stdafx.h"
#include "OPNBluetoothService.h"

class OPN2002iBluetoothService;
class OPNSendCommandSetting;

/** 
* @enum OPNApiType
* @brief eAPI񋓑
*/
enum OPNApiType{
	OPNApiNone,							//!< API̎wȂ
	OPNApiInitializeSetting,			//!< API InitializeSetting
	OPNApiInitializeSettingBluetooth,	//!< API InitializeSettingBluetooth
	OPNApiGetFirmwareVersion,			//!< API GetFirmwareVersion
	OPNApiSaveSetting,					//!< API SaveSetting
	OPNApiReadBarcode,					//!< API ReadBarcode
	OPNApiGetStoredBarcodeAll,			//!< API GetStoredBarcodeAll
	OPNApiEraseStoredBarcodeAll,		//!< API EraseStoredBarcodeAll
	OPNApiSetDataAndTimeStart,			//!< API SetDataAndTimeStart	
	OPNApiSetDataAndTimeEnd,			//!< API SetDataAndTimeEnd
	OPNApiSetDataAndTimeCommand,		//!< API SetDataAndTimeCommand
	OPNApiGetDataAndTime,				//!< API GetDataAndTime	t̎擾iOPN2002ȉꍇ͓tE̎擾j
	OPNApiGetDataAndTime2,				//!< API GetDataAndTime2 ̎擾iOPN3002î݁j
	OPNApiGetBatteryLevel,				//!< API GetBatteryLevel
	OPNApiGetSetting,					//!< API GetSetting	
	OPNApiVibratorOn,					//!< API VibratorOn		
	OPNApiBeepBuzzer,					//!< API BeepBuzzer	
	OPNApiCustomCommand,				//!< CustomCommand JX^R}h
	OPNApiCancel						//!< CancelAllCommand R}hLZAPI
};


/**
* @class   IOPN2002iBluetoothServiceDelegate
* @brief   OPN3002iBuetoothServiceɑ΂fQ[^NX
*
* ̃NXpĊe\bhI[o[Ch邱ƂŁA
* OPN2002iBluetoothServiceNX̃Cxg󂯎邱Ƃł܂B
* pNX̃CX^XOPN3002iBuetoothServiceSetDelegate\bhŐݒ肵ĂB
* SetDelegateŐݒ肵fQ[^͏㏑܂B
* ̃NXSetDelegateɍĂуCxg󂯎悤ɂɂ́A
* SetDelegatexsĂB
*/
class IOPN2002iBluetoothServiceDelegate : public IOPNBluetoothServiceDelegate
{
public:
	/**
	* @brief GetFirmwarěʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidGetFirmware( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief ReadBarcoděʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidReadBarcode( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief GetStoredBarcoděʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidGetStoredBarcode( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief SaveSettinǧʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^	 
	*/
	virtual void OnDidSaveSetting( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief SetDateAndTiměʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidSetDateAndTime( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief GetDateAndTiměʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidGetDateAndTime( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief GetBatteryLeveľʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidGetBatteryLevel( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief GetSettinǧʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidGetSetting( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief InitializeSettinǧʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidInitializeSetting( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief InitializeSettingBluetootȟʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidInitializeSettingBluetooth( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief EraseStoredBarcoděʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidEraseStoredBarcode( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief VibratorOňʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidVibratorOn( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief BeepBuzzeřʂMƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnDidBeepBuzzer( OPNBluetoothService *pService, BYTE* pData ) {};

	/**
	* @brief SẴR}h̑MƂʒm܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual void OnCompleteCustomCommand( OPNBluetoothService *pService, BYTE* pData ) {};

};


/**
* @class   OPN2002iBluetoothService
* @brief   OPN2002/OPN2002iAOPN3002/OPN3002iւAPI񋟂VOgNX
*
* OPN2002iBluetoothServiceNXOPNBluetoothServiceNXpāA
* OPN2002/OPN2002iAOPN3002/OPN3002iւAPI񋟂܂B
* vZXŗB̃CX^XłiGoFVOgp^[jB
* OPN2002iBluetoothServiceNX new găCX^Xł܂B
* CX^X擾ɂ GetInstance \bhgpĎQƃ|C^擾ĂB
* CX^X͕͂ł܂BvZXIɎIɔj܂B
* }`XbhS͂܂B
*/
class OPN2002iBluetoothService : public OPNBluetoothService
{
public:

	/**
	* @brief AvŗB̃CX^X擾܂B
	* @return OPN2002iBluetoothServicẽCX^X
	*/
	static OPN2002iBluetoothService &GetInstance(void);

	/** @name API
	*/
	//@{

	/**
	* @brief f[^RN^[̑Sݒ܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidInitializeSettingĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult InitializeSetting();

	/**
	* @brief f[^RN^[Bluetoothݒ܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidInitializeSettingBluetoothĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult InitializeSettingBluetooth();

	/**
	* @brief f[^RN^[̊ɕۑĂݒAsɕۑ܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidSaveSettingĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult SaveSetting();

	/**
	* @brief f[^RN^[Ńo[R[hǂݎJn܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidReadBarcodeĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult ReadBarcode();

	/**
	* @brief f[^RN^[̃f[^o͂܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidGetStoredBarcodeAllĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult GetStoredBarcodeAll();

	/**
	* @brief f[^RN^[̃f[^NA܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidEraseStoredBarcodeAllĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult EraseStoredBarcodeAll();

	/**
	* @brief f[^RN^[̓ݒ肵܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidSetDateAndTimeĂяo܂B
	*
	* @param[in] y Nij
	* @param[in] M 
	* @param[in] d 
	* @param[in] h 
	* @param[in] m 
	* @param[in] s b
	* @return ʃR[h
	*/
	OPNResult SetDateAndTime(const int y,const int M,const int d,const int h,const int m,const int s);

	/**
	* @brief f[^RN^[̓擾܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidGetDateAndTimeĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult GetDateAndTime();

	/**
	* @brief f[^RN^[̓drd擾܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidGetBatteryLevelĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult GetBatteryLevel();

	/**
	* @brief f[^RN^[̃oCu[^[U܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidVibratorOnĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult VibratorOn();

	/**
	* @brief f[^RN^[̃uU[N܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidBeepBuzzerĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult BeepBuzzer();

	/**
	* @brief ML[̃R}hׂăNA܂B
	* @return ʃR[h
	*/
	OPNResult CancelAllCommand();

	/**
	* @brief o[WԂ܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidGetFirmwareVersionĂяo܂B
	* @return ʃR[h
	*/
	OPNResult GetFirmwareVersion();

	/**
	* @brief ݒlԂ܂B
	*
	* R}h̑MɊꍇAIOPN2002iBluetoothServiceDelegate::OnDidGetGetSettingĂяo܂B
	*
	* @return ʃR[h
	*/
	OPNResult GetSetting();

	//@}


	/** @name R}h
	* R}h̃f[^̃L[𑀍AM܂B
	*/
	//@{

	/**
	* @brief R}hL[ɒǉ܂B
	*
	* Ǝ̃R}h𑗐MꍇɎg܂B
	* I PushCommand(const char*, OPNApiType, const int)Ăяo܂B
	* APĨ^Cv OPNApiCustomCommandɐݒ肳A^CAEg5bɐݒ肳܂B
	*
	* @param[in] command BYTE^̃R}h
	*/
	void PushCommand(const char *command);

	/**
	* @brief R}hL[ɒǉ܂B
	* @param[in] command BYTE^̃R}h
	* @param[in] type OPNApiTypew肵܂BʏOPNApiCustomCommandw肵܂B
	* @param[in] timeOut ^CAEgԂbŎw肵܂B
	*/
	void PushCommand(const char *command,OPNApiType type, const int timeOut );

private:
	/**
	* @brief R}hL[玟̃R}h𑗐M܂B
	*/
	void SendNextCommand();
public:

	/**
	* @brief R}h̑MJn܂B
	*
	* PushCommand\bhŒǉR}hL[1MJn܂B
	*
	* @return ʃR[h
	*/
	OPNResult StartSendCommands();

	//@}

protected:
	/// @brief RXgN^
	OPN2002iBluetoothService();

	/// @brief fXgN^
	~OPN2002iBluetoothService();

	/** @name I[o[[h
	* eNXOPNBluetoothServiceNX̃I[o[hłB
	*/
	//@{

  BOOL OnWillReadData( 
    BTHSppConnection *pConnection,
    BTHReadCondition *pReadCondition
    );

  BOOL OnDidReadData( 
    BTHSppConnection *pConnection, 
    BYTE *readData, 
    INT readBytes
    );

	//@}

private:
	OPNSendCommandSetting *m_currentSendCommand;	//!< ݑMׂR}h

	std::queue<OPNSendCommandSetting *> m_commands; //!< R}h̃L[

	BOOL m_bIsSendingCommands;						//!< R}h𑗐Mǂ

	HANDLE m_hEventGetFirmwareVersion;				//!< o[W擾̃Cxgnh

	/**
	* @brief Rs[RXgN^
	* @param[in] service Rs[
	*/
	OPN2002iBluetoothService(const OPN2002iBluetoothService &service);

	/**
	* @breif GetSettingŎ擾f[^ǂݎ܂B
	* 
	* XbhThreadFuncĂяo܂B
	*
	* @return ̏ꍇTRUEAs̏ꍇFALSEXbhɕԂ܂B
	*/
	BOOL ReadSettingData( SOCKET sd );

	/**
	* @brief R}h𑗐M܂B
	*/
	void SendNextCommands();

	/**
	* @brief ͂ꂽ0x03݂邩肵܂B
	* @param[in] byte 
	* @param[in] size byte̒ 
	* @return TRUE : I[݂ / FALSE : I[݂Ȃ 
	*/
	BOOL ExistTerminator( BYTE *byte, size_t size );

	/**
	* @brief R}hM肵܂
	* @return BOOL TRUE : R}hMAFALSE : R}hMĂȂ
	*/ 
	BOOL IsSendingCommands();

	/**
	* @brief R}hMɂ܂
	*/
	void BeginSendCommand();

	/**
	* @brief R}hM~߂܂
	*/
	void EndSendCommands();

	/**
	* @brief ɁwDatexwTimex݂邩f܂B
	* @param[in] str s
	* @return TRUE : Date,Time݂ / FALSE : Date܂Time݂Ȃ
	*/
	BOOL ExistDateAndTime(const char *str);
};


#endif //OPNTERMDESKTOP__OPN2002iBluetoothService_H_